<?php
/*
Plugin Name: seekXL Snapr
Plugin URI: http://www.zyblog.de/wordpress-plugins/seekxl-snapr/
Description: Versieht externen Links mit einen Screenshot Thumbnail mit Hilfe von <a href="http://snapr.seekxl.de/">seekXL Snapr</a>.
Version: 2.0.3
Author: Tim Zylinski
Author URI: http://www.zyblog.de

Copyright 2008 Tim Zylinski  (email : websitecontact [a t ] zylinski DOT de)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

if (!class_exists("SeekXLSnapr")) {
	class SeekXLSnapr {
		var $adminOptionsName = "SeekXLSnaprAdminOptions";

		function SeekXLSnapr() {
		}

		function init() {
			$this->getAdminOptions();
		}

		function getAdminOptions() {
			$seekXLSnaprAdminOptions = array('show_all' => 'true',
				'thumbnail_size' => 'M',
				'use_logo_key' => 'false',
				'logo_key' => '');

			$devOptions = get_option($this->adminOptionsName);

			if (!empty($devOptions)) {
				foreach ($devOptions as $key => $option)
					$seekXLSnaprAdminOptions[$key] = $option;
			}

			update_option($this->adminOptionsName, $seekXLSnaprAdminOptions);

			return $seekXLSnaprAdminOptions;
		}

		function addHeaderCode() {
			$devOptions = get_option($this->adminOptionsName);

			echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/seekxl-snapr/css/bubble.css" />' . "\n";
			if($devOptions['use_logo_key'] == "true") {
				echo "<script type='text/javascript'>var seekXLLogoKey = \"". $devOptions['logo_key'] . "\";</script>";
			}
			if ($devOptions['show_all'] == 'true') {
				echo "<script type='text/javascript'>var seekXLThumbnailSize = \"". $devOptions['thumbnail_size'] . "\";</script>";
				echo "<script type='text/javascript'>var seekXLShowAll = \"". $devOptions['show_all'] . "\";</script>";
			} else {
				echo "<script type='text/javascript'>var seekXLShowAll = \"". $devOptions['show_all'] . "\";</script>";

			}
		    if (function_exists('wp_enqueue_script')) {
				wp_enqueue_script('seekxl_snapr', get_bloginfo('wpurl') . '/wp-content/plugins/seekxl-snapr/js/bubble-min.js');
			}
		}

		function insertSeekXLSnaprClass($content = '') {
				$devOptions = get_option($this->adminOptionsName);
				$thumbnail_size = $devOptions['thumbnail_size'];

				if ($devOptions['show_all'] == 'true'){
					if (function_exists('str_ireplace')) {
						$content = str_ireplace('href="http://','class="seekxlsnapr'.$thumbnail_size.'" href="http://',$content);
						$content = str_ireplace('class="seekxlsnapr'.$thumbnail_size.'" href="' . get_settings("siteurl"),'href="' . get_settings("siteurl"),$content);
					} else {
						$content = str_replace('href="http://','class="seekxlsnapr'.$thumbnail_size.'" href="http://',$content);
						$content = str_replace('class="seekxlsnapr'.$thumbnail_size.'" href="' . get_settings("siteurl"),'href="' . get_settings("siteurl"),$content);
					}
				}
				return $content;
		}

		function printAdminPage() {
			$devOptions = $this->getAdminOptions();

			if (isset($_POST['update_seekXLSnaprSettings'])) {
				if (isset($_POST['seekXLSnaprShowAll'])) {
					$devOptions['show_all'] = $_POST['seekXLSnaprShowAll'];
				}
				if (isset($_POST['seekXLSnaprUseLogo'])) {
					$devOptions['use_logo_key'] = $_POST['seekXLSnaprUseLogo'];
				}
				if (isset($_POST['seekXLSnaprThumbnailSize'])) {
					$devOptions['thumbnail_size'] = $_POST['seekXLSnaprThumbnailSize'];
				}
				if (isset($_POST['seekXLSnaprLogoKey'])) {
					$devOptions['logo_key'] = $_POST['seekXLSnaprLogoKey'];
				}

				update_option($this->adminOptionsName, $devOptions);

				?>
<div class="updated"><p><strong><?php _e("Settings Updated.", "SeekXLSnapr");?></strong></p></div>
			<?php
			}  ?>
<div class=wrap>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h2><?php _e("seekXL Snapr Settings","SeekXLSnapr"); ?></h2>
<h3><?php _e("Show screenshots for all external links?","SeekXLSnapr"); ?></h3>
<p><?php _e("\"Yes\" activates the screenshots for all external links. \"No\" keeps the plugin active, but the screenshot tooltips will be shown only when the links are tagged manually. How this is done, you can learn in <i>readme.txt</i>","SeekXLSnapr"); ?><p>
<label for="seekXLSnaprShowAll_yes"><input type="radio" id="seekXLSnaprShowAll_yes" name="seekXLSnaprShowAll" value="true" <?php if ($devOptions['show_all'] == "true") { echo 'checked="checked"'; }?> /> <?php _e("Yes","SeekXLSnapr"); ?></label>
&nbsp;&nbsp;&nbsp;&nbsp;
<label for="seekXLSnaprShowAll_no"><input type="radio" id="seekXLSnaprShowAll_no" name="seekXLSnaprShowAll" value="false" <?php if ($devOptions['show_all'] == "false") { echo 'checked="checked"'; }?>/> <?php _e("No","SeekXLSnapr"); ?></label>
</p>
<br />
<h3><?php _e("Thumbnail size","SeekXLSnapr"); ?></h3>
<p><?php _e("Choose the size of the screenshot thumbnails.","SeekXLSnapr"); ?></p>
<p>
<select name="seekXLSnaprThumbnailSize" id="seekXLSnaprThumbnailSize"><?php _e("Thubmnail size:","SeekXLSnapr"); ?>
<option <?php if($devOptions['thumbnail_size'] == "T") { echo 'selected'; } ?> value="T"><?php _e("tiny 100x75","SeekXLSnapr"); ?></option>
<option <?php if($devOptions['thumbnail_size'] == "S") { echo 'selected'; } ?> value="S"><?php _e("small 200x150","SeekXLSnapr"); ?></option>
<option <?php if($devOptions['thumbnail_size'] == "M") { echo 'selected'; } ?> value="M"><?php _e("medium 400x300","SeekXLSnapr"); ?></option>
<option <?php if($devOptions['thumbnail_size'] == "L") { echo 'selected'; } ?> value="L"><?php _e("large 640x480","SeekXLSnapr"); ?></option>
</select>
</p>
<br />
<h3><?php _e("Use own logo?","SeekXLSnapr"); ?></h3>
<p><?php _e("To use your own logo, you need to <a href=\"http://snapr.seekxl.de/register/\">register</a> and fill in your logo key below.","SeekXLSnapr"); ?>
<br />
<?php _e("Your own logos will not be shown, until a key is entered and the setting is set to \"Yes\".","SeekXLSnapr"); ?>
</p>
<p>
<label for="seekXLSnaprUseLogo_yes"><input type="radio" id="seekXLSnaprUseLogo_yes" name="seekXLSnaprUseLogo" value="true" <?php if ($devOptions['use_logo_key'] == "true") { echo 'checked="checked"'; }?> /> <?php _e("Yes","SeekXLSnapr"); ?></label>
&nbsp;&nbsp;&nbsp;&nbsp;
<label for="seekXLSnaprUseLogo_no"><input type="radio" id="seekXLSnaprUseLogo_no" name="seekXLSnaprUseLogo" value="false" <?php if ($devOptions['use_logo_key'] == "false") { echo 'checked="checked"'; }?>/> <?php _e("No","SeekXLSnapr"); ?></label>
</p>
<br />
<h3><?php _e("Logo Key","SeekXLSnapr"); ?></h3>
<p><label for="seekXLSnaprLogoKey"><input type="text" id="seekXLSnaprLogoKey" name="seekXLSnaprLogoKey" size="32" value="<?php if ($devOptions['logo_key'] != "") { echo $devOptions['logo_key']; } ?>"></label></p>

<div class="submit">
<input type="submit" name="update_seekXLSnaprSettings" value="<?php _e('Update Settings', 'SeekXLSnapr'); ?>" /></div>
</form>
 </div>
		<?php
		}//End function printAdminPage()

	}
}

// End of plugin class code

// Load i18n
load_plugin_textdomain('SeekXLSnapr', 'wp-content/plugins/seekxl-snapr/i18n');

// Prepare plugin start
if (class_exists("SeekXLSnapr")) {
	$o_SeekXLSnapr = new SeekXLSnapr();
}

//Initialize the admin panel

if (!function_exists("SeekXLSnapr_ap")) {
	function SeekXLSnapr_ap() {
		global $o_SeekXLSnapr;
		if (!isset($o_SeekXLSnapr)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('seekXL Snapr Plugin', 'seekXL Snapr', 9, basename(__FILE__), array(&$o_SeekXLSnapr, 'printAdminPage'));
		}
	}
}

if (isset($o_SeekXLSnapr)) {
	//Actions
	add_action('admin_menu', 'SeekXLSnapr_ap');
	add_action('wp_head', array(&$o_SeekXLSnapr, 'addHeaderCode'), 1);
	add_action('activate_seekxl-snapr/seekxl-snapr.php',  array(&$o_SeekXLSnapr, 'init'));
}
?>